10  ' These values are constants and should not be changed by the user
80  '
90  '
100 ' Change these values to match your LCD module
110 '
120  _C_Lines = 2
130  _C_LineLength = 16
135 ' 			' You shouldn't have to change the next 4 values
140  _C_L1_Start = 0		
150  _C_L2_Start = 64	
160  _C_L3_Start = 20	
170  _C_L4_Start = 84
200 '
210 DIM _Offset(4)
220 _Offset(1) = _C_L1_Start	' load all the offsets into an array
230 _Offset(2) = _C_L2_Start
240 _Offset(3) = _C_L3_Start
250 _Offset(4) = _C_L4_Start
255 '
260 DIM _Text$(4)
265 '
266 ' Change these values to change the initial display message
267 ' Note: if you have a 20 character display, put spaces on the end to fill
268 ' them out to 20 characters length, othewise you get strange characters displayed.
269 '
270 _Text$(1) = "Hello  World I'm"	' load initial display values for the screen
280 _Text$(2) = "a Maximite LCD  "
290 _Text$(3) = "communicating with a"	' if you have a 2 line display, there's no harm leaving these extra lines here
300 _Text$(4) = "4 line HD44780 LCD. "
310 '
320 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
330 ' Start of code
400 '
1000 '
1110 GOSUB 11000            ' Initialise the LCD
1140 GOSUB 12000            ' Send message/s to the LCD
1150 END
1160 '
1170 '
1180 '
10000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
10010 ' V2 LCD driver for standard 16 X 2 and 20 X 4 LCDs
10020 '               James Deakins July 2011, 
10024 ' based on the original 16 X 2 code by
10025 '               Geoff Graham, March 2011
10030 '
10040 ' Example 20 X 4:  HD44780
10070 '
10080 ' To use:
10090 '  - Set up your text messages and number of lines / characters for your LCD
10100 '	 - execute GOSUB 11000 to initialise display
10110 '  - execute GOSUB 12000 to display the text in    
10120 '   LCD_line1$, LCD_line2$, (and LCD_line3$ and LCD_line4$)
10130 '
10140 ' Make sure you have the right pinouts (see below).  There's a new
10142 ' schematic on Geoff's site, but if you have the old one, USE THIS
10145 ' PINOUT INFORMATION INSTEAD OF THE PINOUTS ON THE SCHEMATIC!!
10147 ' **************************************************************
10150 ' Maximite pin 11 is RS, pin 12 is EN. R/W is grounded.
10160 ' >>>pins 13 to 16 are D4 to D7.<<< May be different to schematic!
10165 ' **************************************************************
10180 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
10190 '
10200 '
11000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
11010 ' Initialise the LCD
11020 '
11030 FOR i = 11 TO 16 : SETPIN i, 9 : NEXT i
11040 _LCD_byte = &B0011 : GOSUB 30100 : PAUSE 5   ' reset
11050 _LCD_byte = &B0011 : GOSUB 30100 : PAUSE 5   ' reset
11060 _LCD_byte = &B0011 : GOSUB 30100 : PAUSE 5   ' reset
11070 _LCD_byte = &B0010 : GOSUB 30100 : PAUSE 2   ' 4 bit mode
11080 _LCD_byte = &B00101100 : GOSUB 30000         ' 4 bit, 2 lines (or 4 lines)
11090 _LCD_byte = &B00001100 : GOSUB 30000    ' display on, no cursor
11100 _LCD_byte = &B00000110 : GOSUB 30000    ' increment on write
11110 _LCD_byte = &B00000001 : GOSUB 30000    ' clear display
11115 pause 2
11120 RETURN
11130 '
11140 '
12000 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
12010 ' send the lines of text to the LCD
12020 '
12030 ' the text is in LCD_Line1$ and LCD_Line2$, and if it's a 4 line, also in LCD_Line3$ and LCD_Line4$
12035 '
12040 _LCD_byte = &B00000001 : GOSUB 30000    ' clear display
12050 pause 2
12060 '
12065 ' Test code from here until the Return statement.  
12066 '
12070 ' GOTO a screen location on the LCD and write a character.
12075 '---------------------------------------------------------
12080 _LCD_Line = 2 : _LCD_Col = 4 : GOSUB 30200 		' GOTO L2, C4
12090 _LCD_byte = ASC("Z") : pin(11) = 1 : gosub 30000		' Write a character to show it works
12100 ' 
12105 ' Turn on a blinking cursor (so we can see where text is being written)
12106 ' ---------------------------------------------------------------------
12110 _LCD_byte = &B00001111 : GOSUB 30000			' Display on, Cursor on, blinking cursor
12120 '
12125 ' Print a non-standard character from the character set held on the LCD
12126 ' ---------------------------------------------------------------------
12130 _LCD_byte = &HF4 : pin(11) = 1 : GOSUB 30000		' print the ohm symbol
12140 ' 							' note that the cursor didn't need to be moved 
12145 ' Pause long enough for the tester to see the results
12146 ' ---------------------------------------------------
12150 pause 2000
12160 '
12165 ' Display the default messages for the lines (defined at beginning of the code)
12166 ' -----------------------------------------------------------------------------
12167 ' This relies on the correct number of lines for the LCD being entered into _C_LINES, and the
12168 ' correct number of characters per line being entered into _C_LineLength.
12169 '
12170 for _Line_out = 1 to _C_LINES
12180	_LCD_byte = 128 + _Offset(_Line_out) : GOSUB 30000	' select the output line on the LCD
12190	for _LCD = 1 to _C_LineLength
12200		_LCD_byte = ASC(MID$(_Text$(_Line_out), _LCD, 1))
12210		Pin(11) = 1 : GOSUB 30000			' send the character
12220	next _LCD
12230 next _Line_out
12240 '
12250 ' Pause long enough for the tester to see the results
12260 ' ---------------------------------------------------
12270 pause 2000
12300 '
12310 ' Load a 26 char message into Line 2 (noting that on a 16 / 20 character display, we only see the first 16 / 20 characters)
12320 ' ----------------------------------------------------------------------------------------------------
12330 _LCD_Byte = 128 + _Offset(2) : GOSUB 30000		' goto start of second line (and yes, we're not using the GOTO subroutine)
12340 TestMsg$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
12350 for _LCD = 1 to 26
12360 	_LCD_byte = ASC(MID$(TestMsg$, _LCD, 1))
12370	Pin(11) = 1 : GOSUB 30000				' Send the character
12380 next _LCD
12390 ' 
12400 ' the user will now see the first 16 characters of our test message displayed on the second line
12405 ' 
12410 ' Pause long enough for the tester to see the results
12420 ' ---------------------------------------------------
12430 pause 2000
12500 '
12510 ' Now shift the message so the balance of the second line can be read
12520 ' -------------------------------------------------------------------
12530 '
12540  _LCD_Line = 2 : _LCD_col = 1 : GOSUB 30200		' for variety, we use the LCD LOCATE subroutine
12550  for _LCD = 1 to 40
12560  		_LCD_byte = &B00011000 : GOSUB 30000
12570   	pause 1000
12580  next _LCD
12590 '
12600 ' Note that this shifts both lines left, and you have to shift left 40 times to get back where you started from
12610 ' -------------------------------------------------------------------------------------------------------------
12620 ' Also notice how the text changes to different lines as the message is scrolled.
12625 '
12630 ' Pause long enough for the tester to see the results
12640 ' ---------------------------------------------------
12650 pause 2000
12660 '
12670 ' Now let's use custom code to scroll only the second line
12680 ' --------------------------------------------------------
12690 '
12700 '
12710 TestMsg$ = "This is a really long message that we will scroll across the second line of the LCD screen."
12720 MsgLen = Len(TestMsg$)
12730 for Mask_Offset = 0 to MsgLen - _C_LineLength		' keep track of where we're starting the display window
12735 	_LCD_line = 2 : _LCD_col = 1 : GOSUB 30200		' go to the start of line 2
12740 	for _LCD = 1 to _C_LineLength
12750		_LCD_byte = ASC(MID$(TestMsg$, Mask_Offset + _LCD, 1))
12760		Pin(11) = 1 : GOSUB 30000
12770	next _LCD
12780   if Mask_offset = 0 then pause 2000 else pause 800	' so screen has time to refresh, and user can read it
12790 next Mask_Offset
12990 RETURN
30000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
30010 ' Send a byte to the LCD
30020 ' the data to be sent is in _LCD_byte
30030 '
30040 PIN(13) = _LCD_byte AND &B00010000      ' output the 1st 4 bits
30050 PIN(14) = _LCD_byte AND &B00100000
30060 PIN(15) = _LCD_byte AND &B01000000
30070 PIN(16) = _LCD_byte AND &B10000000
30080 PIN(12) = 1 : PIN(12) = 0               ' tell lcd to accept data
30100 ' Entry point to send just 4 bits to the LCD
30110 PIN(13) = _LCD_byte AND &B00000001      ' output the 2nd 4 bits
30120 PIN(14) = _LCD_byte AND &B00000010
30130 PIN(15) = _LCD_byte AND &B00000100
30140 PIN(16) = _LCD_byte AND &B00001000
30150 PIN(12) = 1 : PIN(12) = 0 : PIN(11) = 0 ' tell lcd to accept data
30160 RETURN
30170 '
30200 ' Cursor LOCATE code
30210 '
30220 ' Move cursor to a location on the LCD screen
30240 ' The line is sent in _LCD_Line, the column is sent in _LCD_Col
30250 _Start = _Offset(_LCD_Line) + _LCD_Col -1
30270 _LCD_byte = 128 + _Start : GOSUB 30000	' move to the requested location
30280 RETURN
